#!/usr/bin/perl

# This file is part of ESTmapper.
# Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
# Authors: Brian Walenz and Liliana Florea
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received (LICENSE.txt) a copy of the GNU General Public 
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



use Cwd 'abs_path';

if ($#ARGV<0) {
    printf STDERR "usage: makepath.pl path [subpath]\n";
    exit(1);
}

@path = split('/',abs_path($ARGV[0]));
if (!@path) {
    print STDERR "makepath.pl: The path '",$ARGV[0],"' does not exist.\n";
    print STDERR "makepath.pl: perhaps you are building from an incomplete CVS?\n";
    print "\n";
    exit(0);
}

@subpath = ();
if ($#ARGV) {
    @subpath = split('/',abs_path($ARGV[1])) ;
    $subpath[0] = '';
}

while(@subpath && @path && $path[0] eq $subpath[0]) {
    shift(@path); 
    shift(@subpath);
}
for (@subpath) {$_ = '..'};

print join("/", @subpath, @path), "/\n";
