#!/usr/bin/perl

# This file is part of ESTmapper.
# Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
# Authors: Brian Walenz and Liliana Florea
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received (LICENSE.txt) a copy of the GNU General Public 
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



# Handle the output argument for msvc and lib building...

@NEWARGS = ();

$cwd = `pwd`;
($cwdhead = $cwd) =~ s/[\/\\][^\/\\]*$//;

$seenlib = 0;
for ($i=0;$i<@ARGV;$i++) {
    if (!$seenlib && $ARGV[$i] !~ /^-/ && $ARGV[$i] =~ /\.lib$/ ) {
	$dest = $ARGV[$i];
	die if ($dest eq "");
	($path = $dest) =~ s/[\/\\][^\/\\]*$//;
	($base = $dest) =~ s/^.*[\/\\]([^\/\\]*)$/\1/;
	($basenoext = $base) =~ s/[.][^.]*$//;
	push @NEWARGS, "-out:$dest";
	$seenlib = 1;
    } else {
	push @NEWARGS, "$ARGV[$i]";
    }
}

$cmd = "lib";
for ($i=0;$i<@NEWARGS;$i++) {
    $cmd .= " $NEWARGS[$i]";
}
print "$cmd","\n";
exec "$cmd";
