/**************************************************************************
 * This file is part of ESTmapper.
 * Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
 * Authors: Brian Walenz and Liliana Florea
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received (LICENSE.txt) a copy of the GNU General Public 
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**************************************************************************/


#ifndef ELIAS_DELTA_ENCODING_H
#define ELIAS_DELTA_ENCODING_H

#include "bitPacking.h"

inline
void
setEliasDeltaEncodedNumber(u64bit *ptr,
                           u64bit  pos,
                           u64bit *siz,
                           u64bit  val) {
  u64bit b = logBaseTwo64(val);
  setEliasGammaEncodedNumber(ptr, pos, siz, b);
  pos += *siz;
  setDecodedValue(ptr, pos, b-1, val);
  *siz += b-1;
}


inline
u64bit
getEliasDeltaEncodedNumber(u64bit *ptr,
                           u64bit  pos,
                           u64bit *siz) {
  u64bit b = getEliasGammaEncodedNumber(ptr, pos, siz) - 1;
  pos  += *siz;
  *siz += b;
  return(u64bitONE << b | getDecodedValue(ptr, pos, b));
}



#endif  //  ELIAS_DELTA_ENCODING_H
