/**************************************************************************
 * This file is part of ESTmapper.
 * Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
 * Authors: Brian Walenz and Liliana Florea
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received (LICENSE.txt) a copy of the GNU General Public 
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**************************************************************************/


#include <stdio.h>
#include <stdlib.h>

#include "bri.h"

int
main(int argc, char **argv) {
  mt_s   *mtctx;
  int     i;

  psetdebug(2);
  psetblocksize(1024);

  palloc(2048);
  palloc(128);
  palloc(999);
  palloc(1);
  palloc(2);
  palloc(3);
  palloc(4);
  palloc(2056);
  palloc(8);
  palloc(2064);
  palloc(8);
  palloc(2072);
  palloc(8);

  pdumppalloc();

  pfree();

  fprintf(stderr, "----------------------------------------\n");

  psetblocksize(10240);

  palloc(2048);
  palloc(128);
  palloc(999);
  palloc(8);
  palloc(8);
  palloc(8);
  palloc(8);
  palloc(2056);
  palloc(8);
  palloc(2064);
  palloc(8);
  palloc(2072);
  palloc(8);

  pdumppalloc();

  pfree();

  psetdebug(0);
  psetblocksize(16 * 1024 * 1024);

  mtctx = mtInit(time(NULL));
  for (i=0; i<512 * 1024; i++)
    palloc(mtRandom32(mtctx) & 0xfff);
  psetdebug(1);
  pfree();

  return(0);
}

