/**************************************************************************
 * This file is part of ESTmapper.
 * Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
 * Authors: Brian Walenz and Liliana Florea
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received (LICENSE.txt) a copy of the GNU General Public 
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**************************************************************************/


#include <stdio.h>

#include "bri.h"

int
main(void) {
  u32bit   errors = 0;
  u32bit   u3 = -1;
  s32bit   s3 = -1;
  u64bit   u6 = -1;
  s64bit   s6 = -1;

  if (sizeof(u32bit) != 4)
    fprintf(stderr, "u32bit has %d bytes (should be 4)!\n", (int)sizeof(u32bit)), errors++;

  if (sizeof(u64bit) != 8)
    fprintf(stderr, "u64bit has %d bytes (should be 8)!\n", (int)sizeof(u64bit)), errors++;

  if (u3 < 0)
    fprintf(stderr, "u32bit is signed (should be unsigned)!\n"), errors++;

  if (s3 > 0)
    fprintf(stderr, "s32bit is unsigned (should be signed)!\n"), errors++;

  if (u6 < 0)
    fprintf(stderr, "u64bit is signed (should be unsigned)!\n"), errors++;

  if (s6 > 0)
    fprintf(stderr, "s64bit is unsigned (should be signed)!\n"), errors++;

  return(errors);
}


