// This file is part of ESTmapper.
// Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
// Authors: Brian Walenz and Liliana Florea
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received (LICENSE.txt) a copy of the GNU General Public 
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#include "sim4parameters.H"
#include "sim4defines.H"

sim4parameters::sim4parameters() {
    _findAllExons               = false;
    _minCoverage                = 0.0;
    _minCoverageLength          = 0;
    _minPercentExonIdentity     = 0;

    _includeDefLine             = true;
    _printAlignments            = false;

    _alwaysReport               = 0;

    _ignorePolyTails            = true;
    _polyTailPercent            = 0.75;

    _mspThresh1                 = 0;
    _mspThresh2                 = 0;

    _mspLimitAbsolute           = 0;
    _mspLimitPercent            = 0.0;

    _relinkWeight               = DEFAULT_RELINK_WEIGHT;

    _wordSize                   = 12;
    _wordSizeInt                = 8;
    _wordSizeExt                = 10;

    _spacedSeed                 = "111111111111";
    _spacedSeedInt              = "11111111";
    _spacedSeedExt              = "1111111111";
    _isSetSpacedSeed            = false;

    _dontForceCanonicalSplicing = false;
    _forceStrandPrediction      = false;
    _spliceModel                = DEFAULT_SPLICE_MODEL;
    _isSetSpliceModel           = false;

    _interspecies               = false;
    _percentError               = 0.20;
    _match                      =  1;
    _imismatch                  = -5;
    _vmismatch                  = -5;
}

sim4parameters::~sim4parameters() {
}
