/**************************************************************************
 * This file is part of ESTmapper.
 * Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
 * Authors: Brian Walenz and Liliana Florea
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received (LICENSE.txt) a copy of the GNU General Public 
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**************************************************************************/


#include "sim4polish.h"


void
s4p_removeAlignments(sim4polish *p) {
  int i;

  if (p) {
    for (i=0; i<p->numExons; i++) {
      free(p->exons[i].estAlignment);
      p->exons[i].estAlignment = 0L;

      free(p->exons[i].genAlignment);
      p->exons[i].genAlignment = 0L;
    }
  }  
}


void
s4p_removeDeflines(sim4polish *p) {
  if (p) {
    free(p->estDefLine);
    p->estDefLine = 0L;

    free(p->genDefLine);
    p->genDefLine = 0L;
  }
}


void
s4p_destroyPolish(sim4polish *p) {
  if (p) {
    int i;
    for (i=0; i<p->numExons; i++) {
      free(p->exons[i].estAlignment);
      free(p->exons[i].genAlignment);
    }
    free(p->exons);
    free(p->comment);
    free(p->estDefLine);
    free(p->genDefLine);
    free(p);
  }
}
