// This file is part of ESTmapper.
// Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
// Authors: Brian Walenz and Liliana Florea
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received (LICENSE.txt) a copy of the GNU General Public 
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#ifndef SIM4_POLISH_LIST_H
#define SIM4_POLISH_LIST_H

#include "sim4polish.h"

//
//  A list of sim4polishes
//

class sim4polishList {
public:
  sim4polishList();
  sim4polishList(char const *filename);
  ~sim4polishList();

  void          push(sim4polish *p);
  u32bit        length(void)         { return(len); };

  sim4polish   *operator[](u32bit i) { if (i >= len) return(0L); return(list[i]); };
  sim4polish   *get(u32bit i)        { if (i >= len) return(0L); return(list[i]); };

  void          sortBycDNAIID(void);
  void          sortByGenomicIID(void);

  //  Removes polishes below the specified quality
  void          filterByQuality(u32bit minI, u32bit minC);
private:
  u32bit        len;
  u32bit        max;
  sim4polish  **list;
};


#endif  //  SIM4_POLISH_LIST_H
