/**************************************************************************
 * This file is part of ESTmapper.
 * Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
 * Authors: Brian Walenz and Liliana Florea
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received (LICENSE.txt) a copy of the GNU General Public 
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>

#include "sim4polish.h"

int
main(int argc, char ** argv) {
  sim4polish  *p;
  int          c[101] = {0};
  int          i[101] = {0};
  int          x;
  FILE        *C;
  FILE        *I;
  FILE        *S;

  if (isatty(fileno(stdin))) {
    fprintf(stderr, "creates three files:\n");
    fprintf(stderr, "  coverage.histogram\n");
    fprintf(stderr, "  identity.histogram\n");
    fprintf(stderr, "  c-vs-i.scatter\n");
    fprintf(stderr, "\n");
    fprintf(stderr, "error: I cannot read polishes from the terminal!\n\n");
    exit(1);
  }

  C = fopen("coverage.histogram", "w");
  I = fopen("identity.histogram", "w");
  S = fopen("c-vs-i.scatter", "w");

  while ((p = s4p_readPolish(stdin)) != 0L) {
    fprintf(S, "%d %d\n", p->percentIdentity, p->querySeqIdentity);

    i[p->percentIdentity]++;
    c[p->querySeqIdentity]++;

    s4p_destroyPolish(p);
  }

  for (x=0; x<101; x++) {
    fprintf(C, "%d\n", c[x]);
    fprintf(I, "%d\n", i[x]);
  }

  fclose(C);
  fclose(I);
  fclose(S);

  return(0);
}
