// This file is part of ESTmapper.
// Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
// Authors: Brian Walenz and Liliana Florea
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received (LICENSE.txt) a copy of the GNU General Public 
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#include <stdio.h>
#include <stdlib.h>
#include <new>

//  g++ -g -Wall -o test test.C ; ./test
//  Segmentation fault
//  crashes at i = 0, j = 66863104 -- just slightly below my shell enforced memory limit
//
//  xlC -q64 -g -qfullpath -qlanglvl=newexcp -o test test.C ; ./test
//  Not caught.
//  xlC -q64 -g -qfullpath -qlanglvl=nonewexcp -o test test.C ; ./test
//  Not caught.
//  xlC -q64 -g -qfullpath -qlanglvl=ansi -o test test.C ; ./test
//  Not caught.
//  xlC -q64 -g -qfullpath -qlanglvl=strict98 -o test test.C ; ./test
//  Not caught.
//  

#define SIZE (1024 * 1024 * 1024)

void oom(void) {
  fprintf(stderr, "oom reached.\n");
  exit(1);
}


int
main(void) {
  int   i = 0;
  int  *x[1024 * 1024];

  set_new_handler(oom);

  while (1) {
    try {
      x[i] = new int [SIZE];
    } catch (std::bad_alloc) {
      fprintf(stderr, "Caught (bad_alloc).\n");
      exit(1);
    } catch (...) {
      fprintf(stderr, "Caught (...).\n");
      exit(1);
    }

    if (x[i] == 0L) {
      fprintf(stderr, "Not caught.\n");
      exit(1);
    }

#if 1
    for (int j=0; j<SIZE; j += 8192)
      x[i][j] = 0;
#endif

    fprintf(stderr, "i=%d\n", i++);
    fflush(stderr);
  }
}
