#!/usr/bin/perl

# This file is part of ESTmapper.
# Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
# Authors: Brian Walenz and Liliana Florea
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received (LICENSE.txt) a copy of the GNU General Public 
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



#                    Confidential -- Do Not Distribute
#   Copyright (c) 2002 PE Corporation (NY) through the Celera Genomics Group
#                           All Rights Reserved.

package fasta;

use strict;

$| = 1;

sub import () {
}


######################################################################
#
#  Function to stream a multi-fasta file.  Usage:
#
#  my $header;
#  my $sequence;
#
#  open(F, "< $ARGV[0]");
#  while (!eof(F)) {
#    ($header, $sequence) = nextFastA(*F);
#    print ">$header\n";
#    print "$sequence\n";
#  }
#  close(F);
#
sub nextFastA {
    my ($fh) = @_;
    my $h;
    my $s;

    if (!eof($fh)) {
        my $sep = $/;        #  Save the file line separator

        $/ = "\n";
        $h = <$fh>;

        $h =~ s/^\s+//;
        $h =~ s/\s+$//;

        #chomp $h;

        $/ = ">";
        $s = <$fh>;
        $s =~ s/\s//gm;

        #  Fix things -- the '>' is at the start of the header only if this
        #  is the first sequence read from the file.  Likewise, the sequence
        #  will have the '>' at the end if it is not the last sequence read.
        #
        $h =~ s/^>//g;
        $s =~ s/>$//g;

        $/ = $sep;        #  Restore the file line separator
    }

    return($h, $s);
}
