/**************************************************************************
 * This file is part of ESTmapper.
 * Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
 * Authors: Brian Walenz and Liliana Florea
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received (LICENSE.txt) a copy of the GNU General Public 
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**************************************************************************/


#ifndef FASTA_SIMPLE_H
#define FASTA_SIMPLE_H

//
//  A very simple C based fasta reader.  No random access, just open a file,
//  get sequence, get sequence, get sequence, close file.
//

#include "libbritypes.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  char     *header;
  u32bit    headerLen;
  char     *seq;
  u32bit    seqLen;
} fastaSequence;


typedef struct {
  FILE     *fileptr;
  char     *filename;
} fastaReader;


fastaReader    *FastAopen(char *filename);
fastaSequence  *FastAget(fastaReader *r);
void            FastAfree(fastaSequence *f);
void            FastAclose(fastaReader *r);


#ifdef __cplusplus
}
#endif

#endif  //  FASTA_SIMPLE_H
