/**************************************************************************
 * This file is part of ESTmapper.
 * Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
 * Authors: Brian Walenz and Liliana Florea
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received (LICENSE.txt) a copy of the GNU General Public 
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**************************************************************************/


#ifndef FASTA_C_H
#define FASTA_C_H

#include <stdio.h>

//
//  A limited FastAWrapper wrapper that is callable from C
//

#ifdef __cplusplus
extern "C" {
#endif

void           *createFastA(char *file);
void            destroyFastA(void *c);

char           *getFastAsequence(void *c, int idx);
int             getFastAsequenceLength(void *c, int idx);
char           *getFastAheader(void *c, int idx);

#if 0
//  Not implemented!
unsigned char  *getFastAsequenceReverseComplement(void *c, int idx);
#endif

#ifdef __cplusplus
}
#endif

#endif  // FASTA_C_H
